/* 
(C) OOMusou 2010 http://oomusou.cnblogs.com

Filename    : mux_if_else_if.v
Simulator   : NC-Verilog 5.4 + Debussy 5.4 v9 + Quartus II 8.1
Description : mux by mutiple if
Release     : Sep.1,2010 1.0
*/

`timescale 1 ns/1 ns

module mux_multi_if (
  a_i,
  b_i,
  c_i,
  d_i,
  sel_i,
  q_o
);

input a_i, b_i, c_i, d_i;
input [1:0] sel_i;
output q_o;

reg q_o;

always@(sel_i or a_i or b_i or c_i or d_i) begin
  q_o = 1'bx;

  if (sel_i == 2'b00) 
    q_o = a_i;
    
  if (sel_i == 2'b01) 
    q_o = b_i;
    
  if (sel_i == 2'b10)
    q_o = c_i;
    
  if (sel_i == 2'b11)
    q_o = d_i;
end

endmodule